<template>
  <div class="create-credential">
    <div class="container-fluid">
      <div class="row">
        <div class="col-12">
          <div class="title">Create new issue</div>
          <div class="subtitle"></div>
          {{projectId}}
          <div class="input" v-if="!projectId">
            <label>Project</label>
            <div class="input-wrapper">
              <input id="project-name" type="text" placeholder="Project" v-model="project" />
            </div>
          </div>
          <div class="input">
            <label>Caption</label>
            <div class="input-wrapper" @click="$refs.slug.focus()">
              <input
                    id="issue-caption"
                ref="slug"
                type="text"
                placeholder="issue-1"
                v-model="caption"
              />
            </div>
          </div>
          <div class="input">
            <label>Description</label>
            <div class="input-wrapper">
              <input
                      id="project-description"
                type="text"
                placeholder="This is a very important project"
                v-model="description"
              />
            </div>
          </div>
        </div>
      </div>
    </div>
    <button class="button color-2 float-right" id="create-project-popup" @click="createIssueClicked">
      Create Issue
    </button>
    <br /><br />
  </div>
</template>

<script>
import { mapActions } from "vuex";

export default {
  data() {
    return {
      project: "",
      caption: "",
      description: ""
    };
  },
  props: ['projectId'],
  methods: {
    ...mapActions("issueModule", ["createIssue"]),
    createIssueClicked() {
      if(this.projectId) {
        this.project = this.projectId
      }
      const payload = {
        project: this.project,
        caption: this.caption,
        description: this.description
      };
      this.createIssue(payload).then(() => {
        this.$toasters["main"].success("Issue created!");
        this.$emit("close");
      }).catch((error) => {
        this.$toasters["main"].error(error.response.data.message);
      });
    }
  },
  watch: {
    displayName: function(newVal) {
      this.name = "";
      for (let i = 0; i < newVal.length; i++) {
        const char = newVal.charAt(i);
        switch (char) {
          case " ":
            this.name += "-";
            break;
          default:
            this.name += char.toLowerCase();
            break;
        }
      }
    }
  }
};
</script>

<style lang="scss">
.create-credential {
  padding-top: 10px;
  padding-bottom: 10px;
}
</style>
